#ifndef MSP_NET_SOCKADDR_H_
#define MSP_NET_SOCKADDR_H_

#include <string>
#ifndef WIN32
#include <sys/socket.h>
#endif
#include "constants.h"

namespace Msp {
namespace Net {

class SockAddr
{
protected:
	SockAddr() { }
public:
	virtual ~SockAddr() { }

	static SockAddr *create(const sockaddr &sa) { return create(reinterpret_cast<const sockaddr_storage &>(sa)); }
	static SockAddr *create(const sockaddr_storage &);

	virtual SockAddr *copy() const = 0;

	virtual Family get_family() const = 0;
	virtual std::string str() const = 0;

	/** Fills a struct sockaddr with information from this SockAddr.  Returns
	the number of bytes used. */
	virtual unsigned fill_sockaddr(sockaddr &) const = 0;
	virtual unsigned fill_sockaddr(sockaddr_storage &) const;
};

} // namespace Net
} // namespace Msp

#endif
